TopoViewer: all layers are added as visible while code asks them NOT to be
2014-10-10 04:36 AM - Sandro Santilli

Status: Closed

Priority: Severe/Regression

Assignee: Martin Dobias

Category: DB Manager

Affected QGIS version:2.4.0 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 19669
Description

I guess something changed in the TOC api as the TopoViewer plugin of the DBManager now adds all layers as visible even if it makes its
best to request then NOT to be.

Code snippet:

# NODES

group = legend.addGroup(u'Nodes', False, supergroup)

# should not be needed: #6938

legend.setGroupVisible(group, False)

layer = QgsVectorLayer(uri.uri(), u'%s.node' % toponame, provider)
registry.addMapLayers([layer])

legend.setLayerVisible(layer, False)
legend.setLayerExpanded(layer, False)

legend.moveLayer(layer, group)

Associated revisions

Revision 1ff2ad3c - 2014-10-14 11:43 PM - Sandro Santilli

[TopoViewer] fix layer visibility after QgsLegendinterface API changes

It was broken with 2.4, whereas QgsLegendInterface::movelLayer started
forcing layer visibility on (undocumented behaviour).

Fixes #11382

Revision 3546b325 - 2014-10-21 07:19 AM - Martin Dobias
Fix #11382 (keep check state of the moved layer)
Cloning of the existing node will preserve the check state, in addition

it will keep other custom properties that would be lost prevously.

History

#1 - 2014-10-10 04:40 AM - Sandro Santilli
- Affected QGIS version changed from master to 2.4.0

Link to more code:
https://github.com/qgis/QGIS/blob/final-2_4 0/python/plugins/db_manager/db_plugins/postgis/plugins/qgis_topoview/ _init __.py#L104-L118

It looks like 2.4 was also affected :(

#2 - 2014-10-10 04:41 AM - Sandro Santilli

2.2.0 was fine

#3 - 2014-10-10 07:14 AM - Giovanni Manghi

- Priority changed from Normal to Severe/Regression

#4 - 2014-10-10 07:49 AM - Jiirgen Fischer

- Subject changed from DBManager TopoViewer: all layers are added as visible while code asks them NOT to be to TopoViewer: all layers are added
as visible while code asks them NOT to be

- Category changed from Python plugins to DB Manager

#5 - 2014-10-14 06:19 AM - gillian milani

The moveLayer(layer, group) make your layer visible.

So it's normal behavior.

Just change the order of commands, it sould work fine.

#6 - 2014-10-14 02:38 PM - Sandro Santilli

Thank you Gillian, the change fixes the problem. But as of version 2.2 the behaviour was different.

Also, the API documentation doesn't say anything about movelLayer making the layer visible:
http://qgis.org/api/classQgsLegendinterface.html#a23183b102f51dfecb81b26ea570ff224

#7 - 2014-10-14 04:07 PM - Sandro Santilli
- Status changed from Open to Closed

Fixed in changeset commit:"1ff2ad3cc3fadbdca691f83497f96e83a6cc898b".

#8 - 2014-10-15 11:52 PM - Salvatore Larosa

| would reopen this issue as the movelLayer should not make the layer visible if it was not.
IMO, the normal behavior when moving a layer into a group is keeping the initial state of the layer.

here my proposal patch: https:/github.com/qgis/QGIS/pull/1629

| also think you can drop all the stuff like "should not be needed: #6938" from topoviewer plugin :)

Thoughts?
#9 - 2014-10-16 02:28 AM - Sandro Santilli
- Status changed from Closed to Reopened

Agreed, reopened.

#10 - 2014-10-20 10:23 PM - Martin Dobias
- Status changed from Reopened to Closed

Fixed in changeset commit:"3546b325a5¢c335ac960494259bb006514111c08d".

#11 - 2014-10-21 02:08 AM - Sandro Santilli

Thanks, Martin. Could you also look at #6938 since you're at it ? Would be nice to drop other hacks from the plugin, like
https://github.com/qgis/QGIS/blob/final-2_4 0/python/plugins/db_manager/db_plugins/postgis/plugins/qgis_topoview/ _init__.py#L154-L155

#12 - 2014-10-21 02:20 AM - Martin Dobias

| think #6938 should not be an issue since 2.4 because the logic for visibility has been rewritten. Would you mind to check if your code works without that

workaround in 2.4 / master - and eventually close that ticket?
